function CriarContaController(ScreenService, General, engine, templateManager, MessageService) {
    
    this.onEnter = function(widget){
        widget.newRow();
        this.setTOSUrl(widget);
        widget.currentRow.tos_confirmation = 'N';
    };
    
    this.setTOSUrl = function(widget){
        const tosField = widget.fields.find(f => f.name === 'tos_confirmation');
        const TOSWidget = templateManager.container.getWidget("tosIframe");
        const hideToolbarPage = '#toolbar=0&navpanes=0';
        if(tosField){
            //const tosURL = getLocalVar('tosURL');
            const tosURL = 'https://drive.google.com/viewerng/viewer?embedded=true&url=' + getLocalVar('tosURL');
            tosField.tosUrl = tosURL + hideToolbarPage;
            TOSWidget.sourceUrl = tosURL + hideToolbarPage;
        }

    };

    this.submit = function(widget) {
        const hasAcceptedTermsOfService = widget.currentRow.tos_confirmation === 'Y';
        if (widget.isValid() && hasAcceptedTermsOfService) {
            var currentRow = widget.currentRow;
            
            if (currentRow.email == currentRow.confEmail && currentRow.email !== 'anonimo@anonimo.com') {
                if (currentRow.password == currentRow.confPw) {
                    General.callRestEngine("/createAccount", "Row", currentRow).then(function(){
                        MessageService.showMessageByCode('MSG_SUBMIT_ACCOUNT_SUCCESS');
                        ScreenService.openWindow('product#login');
                    }, function(response){
                        var errorMsg = "Erro";
                        if (response.data && response.data.error) {
                            errorMsg = response.data.error;
                        } else if(response.error){
                            errorMsg = response.error;
                        }
            
                        ScreenService.showMessage(ScreenService.i18n(errorMsg), 'E');
                    });
                }
                else {
                    MessageService.showMessageByCode('MSG_VALID_PWACCOUNT_SUBMIT');
                    currentRow.newPw = "";
                    currentRow.confirmPw = "";
                }
            } else {
                MessageService.showMessageByCode('MSG_VALID_EMAIL_SUBMIT');
                currentRow.newPw = "";
                currentRow.confirmPw = "";
            }
        } else if(!hasAcceptedTermsOfService) {
            MessageService.showMessageByCode('MSG_ACCEPT_SERVICE_TERM');
        }
    };
    
    this.cancel = function(widget){
        ScreenService.openWindow('product#login');
    };

    this.showRemoveAccountConfirmationDialog = function(){
        MessageService.confirmMessageByCode('MSG_DELETE_ACCOUNT', null, {
            type: 'question',
            success: () => {
                General.callRestEngine("/removeAccount", "Row", {}).then(() => {
                    engine.forceLogOut();             
                });
            }
        });
    };

    this.showTermsOfServiceWidget = function(args){
        const clickedElement = args && args.e && args.e.target ? args.e.target : null;
        if (!clickedElement || typeof clickedElement.hasAttribute !== 'function') return;
        const openTermsOfService = clickedElement.hasAttribute('terms-of-service');
        if(openTermsOfService){
            const TOSWidget = templateManager.container.getWidget("tosIframe");
            ScreenService.openPopup(TOSWidget);
            console.log("TOIS");
        }
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('CriarContaController', CriarContaController);
});