## Zeedhi Filter Preferences

zh-filter-preferences is a library to add general filters to Zeedhi's grids.

You can start following the steps below:

 - Add on your project bower.json file this dependency

  - Example:

```javascript
    "dependencies": {
        "zh-customizations-service": "*",
        "zh-filter-preferences": "*"
    }
```
 - Run `bower install`

 - Inject the library file on your index.html project file.

   - Example:

```html
<!-- Zeedhi Grid Filter -->
<script src="MY_BOWER_COMPONENTS_PATH/zh-filter-preferences/dist/zhFilterPreferences.js"></script>
Or the minified version
```html
<!-- Zeedhi Preferences -->
<script src="MY_BOWER_COMPONENTS_PATH/zh-layout-preferences/dist/zhFilterPreferences.min.js"></script>
```
```
### How to use:

- To create a an action on your widget floating button you should have the property FloatingControl of your widget structured like this:

```javascript
"floatingControl": {
    "customizationAction": {
        "layout": false,
        "filter": true,
        "view" : false
    }
}
```
  - Pay attention on your `filter` property, it needs to be true;

- To open the filter configurations popup wherever you want you cant Inject on your controller `zhFilterPreferences` and call the method `startFiltering` from it passing your widget as parameter.
  - Example:

```javascript
"events": [
    {
        "name": "ActionEvent",
        "code": "zhFilterPreferences.startFiltering(yourGridWidget)",
        "id": "1589480891951sdasd848201320"
    }
]
```

### Options:

- There are three events which you can subscribe to in your grid widget, `GridFilterBeforeApply`, `GridFilterAfterApply`, `GridFilterAfterCancel`

- If you want to show the current filter information on a stripe, put the stripe's name in a property *`stripeToShowGridFilterInfo`* inside your grid widget.

- If you need to make some changes on the field apresentation you can put the "filterProperties" object in it.

> It is possible to hide some field from stripe by setting `showInStripe` to false

- Example:

```javascript
{
    "id": "1589480892434749191313",
    "label": "Label on Grid",
    "filterProperties" : {
        "operator":"NOT_IN",
        "label": "Label on filter Popup"
    },
    "name": "NAME",
    "isVisible": true,
    "showOnList": true,
    "sideColumn": true,
    "align": "center",
    "events": [
        {
            "name": "FieldOnClick",
            "code": "SampleController.cellClick(args)",
            "id": "15894808925626689541314"
        }
    ],
    "template": "field/text-edit.html",
}
```